/*-------------------------------------------------------------------------
 *
 * param_data.hpp
 *
 *         : BSD.
 *         Copyright (c) 2004 Andrei V. Shetuhin
 *
 *             
 *
 *
 *-------------------------------------------------------------------------
 */
#ifndef _PARAM_DATA_HPP__
#define _PARAM_DATA_HPP__ 1

#ifdef WIN32
#pragma warning (disable : 4786)
#endif

// C Includes

// C++ Includes
#include <stdexcept>
#include <string>
#include <vector>
#include <map>

// Local Includes


namespace template_parser_ns
{

class param_data;
// 
typedef std::string                         t_param_str;
// 
typedef std::vector<param_data *>           t_param_array;
// 
typedef std::map<std::string, param_data *> t_param_hash;

//
//  
//
class param_data
{
public:
	enum e_value_type { VAR, ARRAY, HASH };

	// 
	param_data(e_value_type eIType = VAR);

	//     VAL
	t_param_str   *      val();
	//     ARRAY
	t_param_array *      array();
	//     HASH
	t_param_hash  *      hash();

	//  
	e_value_type get_value_type();

	//    
	param_data * hash_insert_new_var(const std::string &sKey, const std::string &sValue);

	//    
	param_data * hash_insert_new_array(const std::string &sKey);

	//    
	param_data * array_insert_new_var(const std::string &sKey);

	//    
	param_data * array_insert_new_hash();

	//    
	void hash_erase_var(const std::string &sKey);

	// 
	~param_data() throw();

private:
	// 
	param_data                 * parent;
	//  
	e_value_type                 type;
	// 
	void                       * value;
	// Undef
	bool                         undef;
};
} // namespace template_parser_ns
#endif // _PARAM_DATA_HPP__
// End.
